/* 	@author : Sergio Decherchi
 	@date : 18:09 12/02/2004
 	@Version 0.1
 */	


import java.io.*;
import java.util.*;


public class Archivio
{
	Hashtable casa;
	Hashtable anno;
	TreeMap	  titoli;
	BufferedReader stdin;
	String linea;
	
	
	public Archivio()
	{
		casa = new Hashtable();
		anno = new Hashtable();
		titoli= new TreeMap();
		
	}

	public static void main(String[] argv)
	{
		(new Archivio()).execute();
		
	}

	void execute()
	{
		
		
		stdin = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("\n\nArchivio 0.1 by SedekFX\nper aiuto contattatemi: sedekfx@libero.it\n\n");
		while(true)
		{
			
			System.out.print("\n\n1)Leggi\n2)Elimina\n3)Aggiungi\n4)Cerca per anno\n5)Cerca per casa\n6)Stampa tutto\n7)Esci \n\n? > ");
			try
			{
				linea = stdin.readLine();
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
				throw new StandardInputException("Errore di IO su stdin");
			}

			if(linea.equals("7"))
			{
				esci();
			}
			else if(linea.equals("1"))
			{
				leggi();
			}
			else if(linea.equals("2"))
			{
				elimina();
			}
			else if(linea.equals("3"))
			{
				aggiungi();
			}
			
			else if(linea.equals("4"))
			{
				anno();	
			}
			else if(linea.equals("5"))
			{
				casa();	
			}
			else if(linea.equals("6"))
			{
				System.out.println(anno);
			}
			else 
				System.out.println("Comando non valido");
		}
	}


public void casa()
{
	System.out.print("Casa ? > ");
					try
					{
					linea = stdin.readLine();
					}
					catch(IOException ioe)
					{
					ioe.printStackTrace();
					throw new StandardInputException(ioe.toString());
					}
					LinkedList lista=(LinkedList)casa.get(linea);
					if (lista==null)
						{
						System.out.println("\nCasa non presente\n");
						return;
						}
					else
						System.out.println(lista);	
}
public void anno()
{
	System.out.print("Anno ? > ");
					try
					{
					linea = stdin.readLine();
					}
					catch(IOException ioe)
					{
					ioe.printStackTrace();
					throw new StandardInputException(ioe.toString());
					}
					LinkedList lista=(LinkedList)anno.get(linea);
					if (lista==null)
						{
						System.out.println("\nAnno non presente\n");
						return;
						}
					else
						System.out.println(lista);	
}
public void leggi()
{
	System.out.print("Nome file ? > ");
	try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}
	BufferedReader br = null;
	int count=0;
	int count2=0;
	try
	{
		br = new BufferedReader(new FileReader(linea));
		Film f=null;
		boolean flag=false;
		while( (linea = br.readLine()) != null)
		{
			 
			
			if(linea.equals("INIZIO"))
			{
				f= new Film(br);		
				 
			}
			else if(linea.equals("FINE"))
			{
				count++;
				LinkedList lista1=null;
				LinkedList lista2=null;
			if (!titoli.containsKey(f.titolo))
			{
				flag=true;
				if (!anno.containsKey(f.anno))
				{
					
					lista1= new LinkedList();
					anno.put(f.anno,lista1);
				}
				lista1 = (LinkedList)anno.get(f.anno);
				lista1.add(f);
				Collections.sort (lista1, new Compara_casa_titolo() );
				
				if (!casa.containsKey(f.casa))
				{
					lista2= new LinkedList();
					casa.put(f.casa,lista2);
				}
				lista2 = (LinkedList)casa.get(f.casa);
				lista2.add(f);
				Collections.sort (lista2, new Compara_anno_titolo() );
				
				
				if (f.regista==null)
					f.regista="ignoto";
				
				if (f.premi==null)
					f.premi="nessuno";
			titoli.put(f.titolo,f);
			}	
				if (flag==false)
					count2++;
				flag=false;	
				f=null;
			}
			else
			{
				
				try
				{
				if ( (linea.substring(0,7)).equals("REGISTA") )
					f.regista=linea.substring(8);
				else if ( (linea.substring(0,5)).equals("PREMI") ) 			
					f.premi=linea.substring(6);
				}
				catch (StringIndexOutOfBoundsException siobe)
				{
					siobe.printStackTrace();
					System.out.println( "\nAlmeno un campo non valido");
					System.exit(0);
				}
			}
		}
	if (count2!=0)
	System.out.println("\nTrovati: "+count+" film di cui: " +count2+" duplicati (quelli duplicati successivi al primo sono scartati)\n" );
	else
	System.out.println("\nTrovati: "+count+" film \n" );
	}
	catch(FileNotFoundException fnfe)
	{
		System.out.println("\nFile assente!");
		return;
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		System.out.println ("Lettura file fallita");
		return;
	}
	finally
	{
		if(br != null)
		{
			try
			{
			br.close();
			}
			catch(IOException ioe)
			{
			ioe.printStackTrace();
			}
		}
	}

}
public void esci()
{
System.out.print("\nEsci e salvi Si/No? >  ");

try
{
linea=stdin.readLine();
}
catch (IOException ioe)
{
	throw new StandardInputException();
}
if (linea.equals("Si"))
{

	PrintWriter out=null;
	try 
	{
		out= new PrintWriter(new BufferedWriter(new FileWriter("stato.txt"))); 
		LinkedList lista =new LinkedList( (titoli.values()) ) ;
		ListIterator i = lista.listIterator(0); 	
		Film f;
		
		while ( i.hasNext() )
		{
			Film tmp = (Film)i.next();
			out.println("INIZIO");
			out.println(tmp.titolo);
			out.println(tmp.anno);
			out.println(tmp.casa);
			out.println("REGISTA "+tmp.regista);
			out.println("PREMI "+tmp.premi);
			out.println("FINE");
		}
		
		if (out!=null)
		{
		out.flush();
		out.close();
		}
		System.exit(0);
	}
	catch (IOException ioe) 
	{
		System.out.println ("Salvataggio stato fallito");
	}

}
else if (linea.equals("No"))
{
	System.exit(0);
}
else
	{
	System.out.println("Comando non riconosciuto");
	return;
	}



}
public void elimina() 
{
	boolean flag=false;
	System.out.print("1)Eliminazione selettiva\n2)Elimina tutto\n3)Torna indietro\n? > ");
	try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}
	if (linea.equals("1"))
	{
	
	System.out.print("\n\nImmetti nome del film da eliminare >  ");	
	try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}

		LinkedList lista =new LinkedList( (titoli.values()) ) ;
		ListIterator i = lista.listIterator(0); 	
		Film f;
		
		while ( i.hasNext() )
		{
			Film tmp = (Film)i.next();
			if (tmp.titolo.equals(linea))
			{
				flag=true;
				LinkedList temp=(LinkedList)casa.get(tmp.casa);
				ListIterator i2 = temp.listIterator(0);
				while (i2.hasNext())
				{
					Film tmp2 =(Film)i2.next();
					if (tmp2.titolo.equals(linea))
						{
						temp.remove(tmp);
						break;
						}
				}
				temp=(LinkedList)anno.get(tmp.anno);
				i2 = temp.listIterator(0);
				while (i2.hasNext())
				{
					Film tmp2 =(Film)i2.next();
					if (tmp2.titolo.equals(linea))
						{
						temp.remove(tmp);
						break;
						}
				}
			
				titoli.remove(linea);
			}
			
			
		}
		}
		else if  (linea.equals("2"))
		{
		flag=true;
		casa = new Hashtable();
		anno = new Hashtable();
		titoli= new TreeMap();
		}
		else if (linea.equals("3"))
		{
			return;
		}
if (flag==false)
	System.out.println ("\nEliminazione fallita film assente\n");
}
public void aggiungi()
{
System.out.println("\n\nImmetti i parametri richiesti");
Film tmp = new Film();
System.out.print("\nTitolo >");	
try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}
tmp.titolo=linea;	
System.out.print("\nAnno >");	
try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}	
tmp.anno=linea;
System.out.print("\nCasa >");	
try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}	
tmp.casa=linea;
System.out.print("\nRegista >");	
try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}	
tmp.regista=linea;
System.out.print("\nPremi >");	
try
	{
	linea = stdin.readLine();
	}
	catch(IOException ioe)
	{
		ioe.printStackTrace();
		throw new StandardInputException(ioe.toString());
	}	
tmp.premi=linea;
LinkedList lista1=null;
LinkedList lista2=null;

if (!titoli.containsKey(tmp.titolo))
{
		if (!anno.containsKey(tmp.anno))
				{
					
					lista1= new LinkedList();
					anno.put(tmp.anno,lista1);
				}
				lista1 = (LinkedList)anno.get(tmp.anno);
				lista1.add(tmp);
				Collections.sort (lista1, new Compara_casa_titolo() );
				
				if (!casa.containsKey(tmp.casa))
				{
					lista2= new LinkedList();
					casa.put(tmp.casa,lista2);
				}
				lista2 = (LinkedList)casa.get(tmp.casa);
				lista2.add(tmp);
				Collections.sort (lista2, new Compara_anno_titolo() );
			titoli.put(tmp.titolo,tmp);
}
else
	System.out.println("\nTitolo gi presente!\n");

}



}